
/*

	simple grid shape commands to jit.gl.sketch
	sier050915
*/

// set up inlets/outlets/assist strings
outlets = 2;
setinletassist(0,"bang calculates lines for grid");
setoutletassist(1,"bang for color commands, etc");
setoutletassist(0,"series of commands");

// global varables and code
var gridx = 10;
var gridy = 10;
var gridz = 10;
var gx = gridx/2;
var gy = gridy/2;
var gz = gridz/2;
var cr = 0.0;
var cg = 1.0;
var cb = 0.0;
var ca=0.03;


function grid(x,y,z)
{
	gridx = x;
	gridy = y;
	gridz = z;
	gx = gridx/2;
	gy = gridy/2;
	gz = gridz/2;
	bang();
}

function glcolor(r,g,b,a)
{
	cr=r; cg=g; cb=b; ca=a;
	bang();
}


function bang()
{
	var i,j,k;
	
	// issue color command first

	outlet(0,"reset");
	outlet(0,"glcolor", cr, cg, cb, ca);

	outlet(1,"bang");

//	post("\n gvalues", gridx,gridy,gridz,gx,gy,gz);


	for (k=-gz;k<=gz;k++) {
		for (i=-gx;i<=gx;i++) {
			for (j=-gy;j<=gy;j++) {
//			post("\n ijk2", i,j,k);
				if(i!=gx) { outlet(0,"linesegment",i,j,k,i+1,j,k); }
				if(j!=gy) { outlet(0,"linesegment",i,j,k,i,j+1,k); }
				if(k!=gz) { outlet(0,"linesegment",i,j,k,i,j,k+1); }
			}
		}
	}

}

